
:- use_package([assertions]).

%% CIAO-specific
:- use_module(library(format)).

%----------------------------------------------------------------------
% Pretty print papers in .pl format
%----------------------------------------------------------------------

pp_papers_pl([]).
pp_papers_pl([H|T]) :- pp_paper_pl(H), pp_papers_pl(T).

pp_paper_pl(prolog_paper(Keyword,List)) :-
	format('~nprolog_paper(~q, [',[Keyword]),
	pp_att_val_pairs_pl(List),
	format('~n [] ] ).~n',[]).

pp_att_val_pairs_pl([[Att,Value],[]]) :-
	!,
	pp_att_val_pairs_doit_pl(Att,Value),
	format(',',[]).
pp_att_val_pairs_pl([[Att,Value]|T]) :-
	T \== [[]],
	pp_att_val_pairs_doit_pl(Att,Value),
	format(',',[]),
	pp_att_val_pairs_pl(T).

pp_att_val_pairs_doit_pl(Att,Value) :-
	format('~n',[]),
	spaces,
	format('[~q,',[Att]),
	pp_val_pl(Att,Value),
	format('] ',[]).

spaces :- format('     ',[]).

pp_val_pl(Att,Value) :- 
	Att \== author,
	Att \== editor,
	!,
	pp_string_pl(Value).
pp_val_pl(author,List) :-
	format(' [',[]),
	pp_val_authors_pl(List).
pp_val_pl(editor,List) :-
	format(' [',[]),
	pp_val_authors_pl(List).

pp_val_authors_pl([H]):-
	!,
	pp_string_pl(H),
	format('] ',[]).
pp_val_authors_pl([H|T]) :-
	pp_string_pl(H),
	format(',',[]),
	pp_val_authors_pl(T).	

pp_string_pl(Value) :-
	nl,
	spaces,
	spaces,
	format('"~s"',[Value]).

%----------------------------------------------------------------------
:- comment(version_maintenance,dir(version)).

:- comment(version(0*4+25,1999/03/16,14:24*29+'MET'), "Changed
   syntax/1 to use_package/1 for 0.9.  (Manuel Hermenegildo)").
%----------------------------------------------------------------------


